﻿
Public Class Form1

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Me.Text = AppTitleAndVersion()
        Load_INI()
        SetZoom()
        MathConverter_Init()
        ListView_Init()
        AddIdentifiersToListView(ListView1)
        RichTextBox1.AddContextMenu()
        RichTextBox2.AddContextMenu()
        RichTextBox3.AddContextMenu()
        RichTextBox4.AddContextMenu()
        RichTextBox1.SuppressSounds_AndCorrect_CtrlKeys_and_Undo()
        RichTextBox2.SuppressSounds_AndCorrect_CtrlKeys_and_Undo()
        RichTextBox3.SuppressSounds_AndCorrect_CtrlKeys_and_Undo()
        RichTextBox4.SuppressSounds_AndCorrect_CtrlKeys_and_Undo()
        Refresh()
        Opacity = 1
        EventsAreEnabled = True
        btn_TranslateBaseFormula.Select()
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Wolfram_StopWaiting()
        Save_INI()
    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        Dim y As Int32
        Dim h As Int32 = (Me.ClientSize.Height - 160) \ 4
        '
        RichTextBox1.Height = h
        y = RichTextBox1.Top + RichTextBox1.Height + 2
        PictureBox1.Top = y
        Label3.Top = y + 6
        btn_TranslateBaseFormula.Top = y
        Label4.Top = y + 6
        '
        RichTextBox2.Top = y + 26
        RichTextBox2.Height = h
        y = RichTextBox2.Top + RichTextBox2.Height + 2
        PictureBox2.Top = y
        Label5.Top = y + 6
        btn_SimplifyWithWolfram.Top = y
        Label6.Top = y + 6
        btn_SolveWithWolfram.Top = y
        Label7.Top = y + 6
        '
        RichTextBox3.Top = y + 26
        RichTextBox3.Height = h
        y = RichTextBox3.Top + RichTextBox3.Height + 2
        PictureBox3.Top = y
        Label8.Top = y + 6
        btn_TranslateReverseFormula.Top = y
        Label9.Top = y + 6
        btn_Test.Top = y
        '
        RichTextBox4.Top = y + 26
        RichTextBox4.Height = h
        '
        RichTextBox1.Width = ListView1.Left - 24
        RichTextBox2.Width = RichTextBox1.Width
        RichTextBox3.Width = RichTextBox1.Width
        RichTextBox4.Width = RichTextBox1.Width
    End Sub

    Private Sub RichTextBox3_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles RichTextBox3.Click
        Wolfram_StopWaiting()
    End Sub

    Private Sub MyTrackBar1_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyTrackBar1.ValueChanged
        If Not EventsAreEnabled Then Return
        SetZoom()
    End Sub

    Private Sub SetZoom()
        Dim z As Single = 1.0F + MyTrackBar1.Value / 10.0F
        RichTextBox1.ZoomFactor = z
        RichTextBox2.ZoomFactor = z
        RichTextBox3.ZoomFactor = z
        RichTextBox4.ZoomFactor = z
    End Sub

    ' ===================================================================================
    '  Accept the first click for MenuStrip, ToolStrip and other controls 
    '  (for example when clicking with the mouse and selecting text in a RichTextBox)
    ' -----------------------------------------------------------------------------------
    '  If the form receives a WM_PARENTNOTIFY (528) message and is not focused 
    '  then the form is activated before to exec the message
    ' ===================================================================================
    <DebuggerStepThrough()> _
    Protected Overrides Sub WndProc(ByRef m As Message)
        If m.Msg = 528 AndAlso Not Me.Focused Then
            Me.Activate()
        End If
        MyBase.WndProc(m)
    End Sub

    ' ===================================================================================
    '  BUTTONS 
    ' ===================================================================================
    Private Sub btn_WolframAlpha_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_WolframAlpha.Click
        Process.Start("https://www.wolframalpha.com")
    End Sub

    Private Sub btn_GraspableMath_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_GraspableMath.Click
        Process.Start("https://graspablemath.com/canvas")
    End Sub

    Private Sub btn_Cymath_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Cymath.Click
        Process.Start("https://www.cymath.com")
    End Sub

    Private Sub btn_MicrosoftMath_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_MicrosoftMath.Click
        Dim s As String = "C:\Program Files\Microsoft Mathematics\MathApp.exe"
        If IO.File.Exists(s) Then
            Process.Start(s)
        Else
            If MessageBox.Show("Please install Microsoft Mathematics" + vbCrLf + vbCrLf + _
                               "Would you like to install it now?", _
                               "Message from MathHelper", _
                               MessageBoxButtons.YesNo) = Windows.Forms.DialogResult.Yes Then
                Process.Start("https://www.microsoft.com/en-us/download/details.aspx?id=15702")
            End If
        End If
    End Sub

    Private Sub btn_MathSymbols_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_MathSymbols.Click
        Process.Start(Application.StartupPath + "\DotNet and Wolfram operators.txt")
    End Sub

    Private Sub btn_Examples_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Examples.Click
        Process.Start("examples.txt")
    End Sub

    ' =====================================================================================
    '  TRANSLATE TO MATH NOTATION
    ' =====================================================================================
    Private Sub btn_TranslateBaseFormula_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_TranslateBaseFormula.Click
        TranslateBaseFormula()
    End Sub

    Private Sub TranslateBaseFormula()
        ' --------------------------------------- parse identifiers
        ParseIdentifiers(RichTextBox1.GetTextWithCRLF())
        ' --------------------------------------- show identifiers
        AddIdentifiersToListView(ListView1)
        ' --------------------------------------- translate to math
        RichTextBox2.SetTextUsingUndo(TranslateToMathNotation(RichTextBox1.GetTextWithCRLF()))
    End Sub

    ' ===================================================================================
    '  SIMPLIFY and SOLVE
    ' ===================================================================================
    Private Sub btn_SimplifyWithWolfram_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_SimplifyWithWolfram.Click
        RichTextBox3.ZoomFactor = 1
        DisableControls()
        InitWolframOptions()
        Wolfram_CreateQuery(RichTextBox2.GetTextWithCRLF(), "simplify", Me.PointToScreen(btn_SimplifyWithWolfram.Location))
        Wolfram_EvaluateAndGetResults(RichTextBox3)
        SetZoom()
        EnableControls()
        chk_WebHTML.Checked = False
        chk_WebXML.Checked = False
    End Sub

    Private Sub btn_SolveWithWolfram_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_SolveWithWolfram.Click
        RichTextBox3.ZoomFactor = 1
        DisableControls()
        InitWolframOptions()
        Wolfram_CreateQuery(RichTextBox2.GetTextWithCRLF(), "solve", Me.PointToScreen(btn_SolveWithWolfram.Location))
        Wolfram_EvaluateAndGetResults(RichTextBox3)
        SetZoom()
        EnableControls()
        chk_WebHTML.Checked = False
        chk_WebXML.Checked = False
    End Sub

    Private Buttons_OldColor As Color
    Private Sub DisableControls()
        Buttons_OldColor = btn_TranslateBaseFormula.BackColor
        btn_TranslateBaseFormula.BackColor = Color.Transparent
        btn_SimplifyWithWolfram.BackColor = Color.Transparent
        btn_SolveWithWolfram.BackColor = Color.Transparent
        btn_TranslateReverseFormula.BackColor = Color.Transparent
        btn_TranslateBaseFormula.Enabled = False
        btn_SimplifyWithWolfram.Enabled = False
        btn_SolveWithWolfram.Enabled = False
        btn_TranslateReverseFormula.Enabled = False
        Label1.Focus()
    End Sub

    Private Sub EnableControls()
        btn_TranslateBaseFormula.BackColor = Buttons_OldColor
        btn_SimplifyWithWolfram.BackColor = Buttons_OldColor
        btn_SolveWithWolfram.BackColor = Buttons_OldColor
        btn_TranslateReverseFormula.BackColor = Buttons_OldColor
        btn_TranslateBaseFormula.Enabled = True
        btn_SimplifyWithWolfram.Enabled = True
        btn_SolveWithWolfram.Enabled = True
        btn_TranslateReverseFormula.Enabled = True
    End Sub

    ' =====================================================================================
    '  TRANSLATE TO VbNet NOTATION
    ' =====================================================================================
    Private Sub btn_TranslateReverseFormula_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_TranslateReverseFormula.Click
        RichTextBox4.SetTextUsingUndo(TranslateToDotNetNotation(RichTextBox3.GetTextWithCRLF()))
    End Sub


    ' =====================================================================================
    '  SUBSTITUTION TEST
    ' =====================================================================================
    Private Sub btn_Test_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Test.Click
        ' ----------------------------------------------- select the line in the TextBox4
        Dim EquationToTest As String = ""
        With RichTextBox4
            If .Lines.Count = 1 Then
                .SelectAll()
            Else

                .SelectLine(.GetFirstSelectedLineIndex)
            End If
            EquationToTest = .GetFirstSelectedLine()
        End With
        '
        ' ----------------------------------------------- parse identifiers
        ParseIdentifiers(RichTextBox1.GetTextWithCRLF())
        ' ----------------------------------------------- show identifiers
        AddIdentifiersToListView(ListView1)
        '
        ' ----------------------------------------------- find the "=" position
        Dim i As Int32 = EquationToTest.IndexOf("=")
        If i < 0 Then Return
        '
        ' ----------------------------------------------- find the part before the "="
        Dim stringFrom As String = " " + Strings.Left(EquationToTest, i)
        stringFrom = " " + TranslateToMathNotation(stringFrom).Trim + " "
        '
        ' ----------------------------------------------- find the part after the "="
        Dim stringTo As String = EquationToTest.Trim.Substring(i + 1)
        stringTo = " (" + TranslateToMathNotation(stringTo).Trim + ") "
        '
        ' ----------------------------------------------- 
        Dim s As String = RichTextBox1.Text
        s = TranslateToMathNotation(s) + " "
        s = s.Replace(stringFrom, stringTo)
        s = TranslateToDotNetNotation(s)
        RichTextBox1.SetTextUsingUndo(s)
        ' -----------------------------------------------
        TranslateBaseFormula()
        ' ----------------------------------------------- 
        RichTextBox3.SetTextUsingUndo("The variable """ + stringFrom.Trim + """ has been substituted" + vbCrLf + _
                                      "Now you can test if the equation is ""TRUE""" + vbCrLf + _
                                      "Press ""Simplify""")
    End Sub

    '("Substitute the selected text in the first equation" + vbCrLf + _
    '"(the selected text must be the part after the ""=""" + vbCrLf + _
    '"and it will substitute the variable before the ""="")")



    ' ===================================================================================
    '  OPTIONS 
    ' ===================================================================================
    Private Sub chk_Approximated_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_Approximated.CheckedChanged
        If chk_Approximated.Checked Then
            chk_MoreDigits.Enabled = True
        Else
            chk_MoreDigits.Enabled = False
        End If
    End Sub
    Private Sub chk_WebSiteHTML_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_WebHTML.CheckedChanged
        If chk_WebHTML.Checked Then chk_WebXML.Checked = False
    End Sub
    Private Sub chk_WebSiteXML_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_WebXML.CheckedChanged
        If chk_WebXML.Checked Then chk_WebHTML.Checked = False
    End Sub
    Private Sub InitWolframOptions()
        Wolfram_Approximated = chk_Approximated.Checked
        Wolfram_MoreDigits = chk_MoreDigits.Checked
        Wolfram_WebAsHTML = chk_WebHTML.Checked
        Wolfram_WebAsXML = chk_WebXML.Checked
    End Sub


    ' ===================================================================================
    '  LIST VIEW for IDENTIFIERS
    ' ===================================================================================
    Private Sub ListView_Init()
        With ListView1
            .Clear()
            .Columns.Add("Letter", 48, HorizontalAlignment.Center)
            .Columns.Add("Identifier", 192, HorizontalAlignment.Left)
            .View = View.Details
            .HideSelection = False
            .LabelEdit = True
            .AllowColumnReorder = False
            .CheckBoxes = False
            .FullRowSelect = True
            .HideSelection = True
            .GridLines = True
            .Sorting = SortOrder.None
            .BringToFront()
            .TabStop = False
        End With
    End Sub

    Private Sub ListView1_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListView1.GotFocus
        ' --------------------------- stop system to set focus to the ListView
        Label1.Select()
    End Sub

    Private Sub ListView1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles ListView1.MouseDown
        Dim lv As ListView = CType(sender, ListView)
        Dim ItemIndex As Int32 = GetListViewItemIndex(lv, e)
        Dim SubItemIndex As Int32 = GetListViewSubitemIndex(lv, e)
        If ItemIndex < 0 Then Return
        If SubItemIndex = 0 Then
            Dim p As Point = lv.Location
            p.Y += lv.Items(ItemIndex).Position.Y + 12
            p.X -= 200
            p = Me.PointToScreen(p)
            Dim s As String = InputBox(vbCrLf + vbCrLf + _
                                       "Please enter the new letter for """ + lv.Items(ItemIndex).Text.Trim + """", _
                                       "", "", p.X + 52, p.Y + 10)
            If s <> "" Then
                s = s.Trim
                s = s(0)
                If s <> "" Then
                    If s = "e" Then
                        MessageBox.Show("The letter ""e"" is reserved for logarithm base", _
                                        "Message from MathHelper")
                    ElseIf s = "i" Then
                        MessageBox.Show("The letter ""i"" is reserved for immaginary symbol", _
                                        "Message from MathHelper")
                    ElseIf s = "n" Then
                        MessageBox.Show("The letter ""n"" is reserved for the ""π n"" construct", _
                                        "Message from MathHelper")
                    ElseIf GetIdentifierSingleLetterIndex(s) > -1 AndAlso _
                           GetIdentifierSingleLetterIndex(s) <> ItemIndex Then
                        MessageBox.Show("The letter """ + s + """ is already used", _
                                        "Message from MathHelper")
                    Else
                        Dim item As ListViewItem = lv.Items(ItemIndex)
                        SetLetterToIdentifierArray(ItemIndex, s)
                        SetSingleLetterToListView(ItemIndex, s)
                        RichTextBox2.SetTextUsingUndo(TranslateToMathNotation(RichTextBox1.GetTextWithCRLF()))
                    End If
                End If
            End If
        Else
            Dim s As String = lv.Items(ItemIndex).Text.Trim
            If Asc(s) < Asc("a") Then
                s = s.ToLower
            Else
                s = s.ToUpper
            End If
            SetLetterToIdentifierArray(ItemIndex, s)
            SetSingleLetterToListView(ItemIndex, s)
            RichTextBox2.SetTextUsingUndo(TranslateToMathNotation(RichTextBox1.GetTextWithCRLF()))
        End If
    End Sub

    Private Sub SetSingleLetterToListView(ByVal line As Int32, ByVal s As String)
        ListView1.Items(line).Text = "     " + s
    End Sub

    Private Function GetListViewItemIndex(ByVal lv As ListView, ByVal e As MouseEventArgs) As Int32
        Dim info As ListViewHitTestInfo = lv.HitTest(e.X, e.Y)
        If info.Item Is Nothing Then Return -1
        Return info.Item.Index
    End Function

    Private Function GetListViewSubitemIndex(ByVal lv As ListView, ByVal e As MouseEventArgs) As Int32
        Dim info As ListViewHitTestInfo = lv.HitTest(e.X, e.Y)
        If info.Item Is Nothing Then Return -1
        Return info.Item.SubItems.IndexOf(info.SubItem)
    End Function

End Class
